
(* EXPRTRAD.PAS: created 12-17-2001 at 10:11 am
   by Yacc Version 2.0, Copyright (c) 1989 Albert Graef, all rights reserved *)


uses LexLib, YaccLib;
 {$I exprlex} { lexical analyser }

var yychar : System.integer;
var yystack : array [1..yymaxdepth] of System.integer;
var yyvals : array [1..yymaxdepth] of yystype;
var yyval : yystype;
var yystackptr : System.integer;
var yyfail, yyacc, yyab : System.boolean;
var yynerrs, yyerr : System.integer;
procedure yyerror; begin yyfail := System.true end;
procedure yyerrok; begin yyerr := 0 end;
procedure yyaccept; begin yyacc := System.true end;
procedure yyabort; begin yyab := System.true end;
procedure yyclearin; begin yychar := -1 end;
procedure yyaction(yyrule : System.integer);
begin case yyrule of
1: ;
2: begin yyval := yyvals[yystackptr-1]
end(*2*);
3: begin yyval := yyvals[yystackptr-3]
end(*3*);
4: begin yyval := yyvals[yystackptr-1]
end(*4*);
5: begin yyval := yyvals[yystackptr-3]
end(*5*);
6: begin yyval := yyvals[yystackptr-1]
end(*6*);
7: begin yyval := yyvals[yystackptr-3]
end(*7*);
8: begin yyval := yyvals[yystackptr-2]
end(*8*);
end(*case*);
end(*yyaction*);

const _ = -11111;
const yyerrortok = -256;
const yyrules = 8;
const yystates = 13;
const yyentries = 120;
const yyrulesize : array [1..yyrules] of System.integer = (
  2,
  1,
  3,
  1,
  3,
  1,
  3,
  2);
const yylsym : array [1..yyrules] of System.integer = (
  1,
  2,
  2,
  3,
  3,
  4,
  4,
  4);
const yydefault : array [0..yystates] of System.integer = (
  _,
  _,
  _,
  -4,
  _,
  _,
  -6,
  _,
  _,
  _,
  -8,
  _,
  -5,
  -7);
const yybase : array [0..yystates] of System.integer = (
  106,
  45,
  46,
  1,
  112,
  113,
  1,
  115,
  116,
  55,
  1,
  58,
  1,
  1);
{$define yytable}
const yynext : array [1..yyentries] of System.integer = (
  6, 7, -2, 8, -2,
  _, 6, 6, _, 6,
  6, 7, _, 13, -3,
  8, -3, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, 0,
  -2, _, _, _, _,
  _, _, _, _, _,
  _, _, -3, _, _,
  5, _, _, _, _,
  4, 5, 5, _, 5,
  5, 4, 4, _, 4,
  4, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, 1, 2, 3,
  _, _, _, 9, 2,
  3, 10, 11, 3, 12);
const yycheck : array [1..yyentries] of System.integer = (
  0, 1, 2, 2, 2,
  _, 4, 5, _, 7,
  8, 9, _, 9, 11,
  11, 11, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, 1,
  2, _, _, _, _,
  _, _, _, _, _,
  _, _, 11, _, _,
  0, _, _, _, _,
  0, 4, 5, _, 7,
  8, 4, 5, _, 7,
  8, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, 0, 0, 0,
  _, _, _, 4, 4,
  4, 5, 7, 7, 8);
function yyparse : System.integer;
  var s : System.integer;
  function next(s, sym : System.integer) : System.integer;
    var i : System.integer;
    begin
      {$ifdef yytable}
      i := yybase[s]+sym;
      if (1<=i) and (i<=yyentries) and (yycheck[i]=s) then
        next := yynext[i]
      else
        next := yydefault[s]
      {$else}
        next := yydefault[s]
      {$endif}
    end(*next*);
  procedure shift(s1 : System.integer);
    begin
      {$ifdef yydebug}
      yydebugmsg(s, 'shift', s1);
      {$endif}
      if yystackptr>yymaxdepth then begin yymsg('yyparse: stack overflow'); yyabort; exit end;
      s := s1;
      yystack[yystackptr] := s;
      yyvals[yystackptr] := yylval;
      inc(yystackptr);
      if yyerr>0 then dec(yyerr)
    end(*shift*);
  procedure error;
    procedure recover;
      begin
        {$ifdef yydebug}
        yydebugmsg(s, '** error **', -1);
        {$endif}
        while (yystackptr>2) and (next(s, yyerrortok)<0) do
          begin
            {$ifdef yydebug}
            yydebugmsg(s, 'recovery pops stack', -1);
            {$endif}
            dec(yystackptr);
            s := yystack[System.pred(yystackptr)]
          end;
        yyerr := 4;
        if next(s, yyerrortok)>=0 then
          shift(next(s, yyerrortok))
        else
          yyabort;
      end(*recover*);
    begin
      case yyerr of
        0: begin yymsg('syntax error'); inc(yynerrs); recover end;
        1,2: recover;
        3: if yychar=0 then
             yyabort
           else
             begin
               {$ifdef yydebug}
               yydebugmsg(s, 'recovery discards', yychar);
               {$endif}
               yychar := -1;
             end;
      end;
    end(*error*);
  procedure reduce(p : System.integer);
    begin
      {$ifdef yydebug}
      yydebugmsg(s, 'reduce by rule', System.pred(p));
      {$endif}
      yyaction(p);
      dec(yystackptr, yyrulesize[p]);
      s := yystack[System.pred(yystackptr)];
      if yystackptr>yymaxdepth then begin yymsg('yyparse: stack overflow'); yyabort; exit end;
      {$ifdef yydebug}
      yydebugmsg(s, 'goto', next(s, yylsym[p]));
      {$endif}
      s := next(s, yylsym[p]);
      yystack[yystackptr] := s;
      yyvals[yystackptr] := yyval;
      inc(yystackptr)
    end(*reduce*);
  begin
    yyacc := System.false; yyab := System.false;
    yyerr := 0; yynerrs := 0;
    yyfail := System.false;
    s := 0;
    yystack[1] := s;
    yystackptr := 2;
    yychar := -1;
    repeat
      if yydefault[s]<>_ then
        reduce(-yydefault[s])
      else
        begin
          if yychar=-1 then
            begin
              yychar := yylex; if yychar<0 then yychar := 0;
              {$ifdef yydebug}
              yydebugmsg(s, 'reading', yychar);
              {$endif}
            end;
          if yyfail or (next(s, -yychar)=_) then
            error
          else if next(s, -yychar)<0 then
            reduce(-next(s, -yychar))
          else if yychar=0 then
            yyaccept
          else
            begin
              shift(next(s, -yychar));
              yychar := -1
            end
        end
    until yyacc or yyab;
    {$ifdef yydebug}
    if yyacc then
      yydebugmsg(s, 'accept', -1)
    else
      yydebugmsg(s, 'abort', -1);
    {$endif}
    if yyacc then
      yyparse := 0
    else
      yyparse := 1
  end(*yyparse*);

var i : integer;
begin
  if yyparse=0 then { done }
end.