
(* EXPRLEX.PAS: created 12-17-2000 at 11:24 pm
   by Lex Version 2.0, Copyright (c) 1989 Albert Graef, all rights reserved *)

  (* EXPRLEX.L: lexical analyzer for EXPR.Y *)
  {$I expr.h}


const yylnl=#10;
const yylbufsize = 255;
const yylsstate0 : System.integer = 0;
var yylsstate : System.integer absolute yylsstate0;
const yylastate0 : System.integer = 0;
var yylastate : System.integer absolute yylastate0;
var yylreturn : System.boolean; yyltok : System.integer;
var yytext : string[yylbufsize];
var yyleng : Byte absolute yytext;
var yyleng0 : Byte;
procedure begin_(s : System.integer);
  begin yylsstate := s end;
procedure return(tok : System.integer);
  begin yylreturn := true; yyltok := tok end;
procedure yymore;
  begin yyleng0 := yyleng end;
procedure yyless(n : System.integer);
  begin
    while yyleng>n do begin unput(yytext[yyleng]); dec(yyleng) end
  end;
procedure echo;
  var i : System.integer;
  begin
    for i := 1 to yyleng do output(yytext[i])
  end;
procedure reject; forward;
procedure yylaction(yylrule : System.integer);
 var result : integer;

begin case yylrule of
0: ;
1:begin		  val(yytext, yylval.number, result);
		  if result=0 then
		    return(NUMBER)
		  else
		    return(ILLEGAL)
		end;

2:begin		  yylval.variable := succ(ord(upcase(yytext[1]))-ord('A'));
		  return(VARIABLE)
		end;

3:return(EOF);
4,
5:return(ord(yytext[1]));
end(*case*);
end(*yylaction*);

const yylrules = 5;
const yylstates = 12;
const yyltrans = 256;
const yylmatch_base : array [-1..yylstates] of System.integer = (
  1,
  1,1,2,3,5,7,9,9,10,10,
  11,11,12);
const yylmatch_entries = 11;
const yylmatch : array [0..yylmatch_entries] of System.integer = (0,
  4,5,3,4,1,4,2,4,1,1,
  1);
const yylendpos_base : array [-1..yylstates] of System.integer = (
  1,
  1,1,2,3,5,7,9,9,10,10,
  11,11,12);
const yylendpos_entries = 11;
const yylendpos : array [0..yylendpos_entries] of System.integer = (0,
  4,5,3,4,1,4,2,4,1,1,
  1);
const yylstop : array [0..yylstates] of System.boolean = (
  FALSE,FALSE,TRUE,TRUE,TRUE,FALSE,TRUE,FALSE,FALSE,FALSE,
  FALSE,FALSE,FALSE);
const yylbase : array [0..yylstates] of System.integer = (
  1,124,-255,-255,-255,-36,-255,-26,87,-11,
  114,97,199);
const yyldefault : array [0..yylstates] of System.integer = (
  2,2,-1,-1,-1,-1,-1,-1,-1,-1,
  -1,-1,-1);
{$define yyltrans}
const yylnext : array [1..yyltrans] of System.integer = (
  -1,-1,-1,-1,-1,-1,-1,-1,-1,7,
  3,8,8,8,8,8,8,8,8,8,
  8,10,10,10,10,10,10,10,10,10,
  10,11,9,11,-1,-1,12,12,12,12,
  12,12,12,12,12,12,4,-1,5,5,
  5,5,5,5,5,5,5,5,-1,-1,
  -1,-1,-1,-1,9,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,
  6,-1,-1,-1,-1,-1,-1,6,6,6,
  6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,
  6,6,6,-1,-1,-1,-1,-1,-1,-1,
  -1,-1,7,3,8,8,8,8,8,8,
  8,8,8,8,12,12,12,12,12,12,
  12,12,12,12,-1,9,-1,-1,-1,-1,
  -1,10,10,10,10,10,10,10,10,10,
  10,5,5,5,5,5,5,5,5,5,
  5,-1,9,-1,-1,-1,-1,9,6,6,
  6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,9,-1,-1,-1,-1,-1,
  6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,12,12,12,12,
  12,12,12,12,12,12);
const yylcheck : array [1..yyltrans] of System.integer = (
  0,-1,-1,-1,-1,-1,-1,-1,-1,5,
  0,5,5,5,5,5,5,5,5,5,
  5,7,7,7,7,7,7,7,7,7,
  7,9,5,9,-1,-1,9,9,9,9,
  9,9,9,9,9,9,0,-1,0,0,
  0,0,0,0,0,0,0,0,-1,-1,
  -1,-1,-1,-1,5,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,
  0,-1,-1,-1,-1,-1,-1,0,0,0,
  0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,
  0,0,0,1,-1,-1,-1,-1,-1,-1,
  -1,-1,8,1,8,8,8,8,8,8,
  8,8,8,8,11,11,11,11,11,11,
  11,11,11,11,-1,8,-1,-1,-1,-1,
  -1,10,10,10,10,10,10,10,10,10,
  10,1,1,1,1,1,1,1,1,1,
  1,-1,10,-1,-1,-1,-1,8,1,1,
  1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,10,-1,-1,-1,-1,-1,
  1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,12,12,12,12,
  12,12,12,12,12,12);


var yylstate, yylrule, yylrule0, yylpos, yylpos0 : System.integer;
var yylends, yylmatches : array [0..yylrules] of System.integer;
procedure reject;
  var r : System.integer;
  begin
    yylrule0 := 0; yylpos0 := yylpos; yyleng0 := yyleng;
    for r := 1 to yylrules do
      if ((yylmatches[r]=yylmatches[yylrule]) and (r>yylrule) or
          (yylmatches[r]<yylmatches[yylrule])) and
         (yylmatches[r]>yylmatches[yylrule0]) then
        yylrule0 := r;
    if yylpos0<yylmatches[yylrule0] then
      while yylpos0<yylmatches[yylrule0] do
        begin
          inc(yyleng0); yytext[yyleng0] := input; inc(yylpos0)
        end
    else
      while yylpos0>yylmatches[yylrule0] do
        begin
          unput(yytext[yyleng0]); dec(yyleng0); dec(yylpos0)
        end
  end(*reject*);
function yylterm : System.boolean;
  var i, s1, isc : System.integer; c : System.char;
  begin
    inc(yylpos);
    if succ(yyleng)=yylbufsize then if yyloverflow then halt(1);
    if yylmatch_base[pred(yylstate)]<yylmatch_base[yylstate] then
      begin
        yylrule := yylmatch[yylmatch_base[pred(yylstate)]];
        for i := yylmatch_base[pred(yylstate)] to pred(yylmatch_base[yylstate]) do
          yylmatches[yylmatch[i]] := yylpos
      end;
    if yylendpos_base[pred(yylstate)]<yylendpos_base[yylstate] then
      begin
        for i := yylendpos_base[pred(yylstate)] to pred(yylendpos_base[yylstate]) do
          yylends[yylendpos[i]] := yylpos
      end;
    if (yyleng=yylbufsize) or yylstop[yylstate] then begin yylterm := System.true; exit end;
    c := input;
    {$ifdef yyltrans}
    isc := yylbase[yylstate]+System.ord(c);
    if (isc<1) or (isc>yyltrans) or (yylcheck[isc]<>yylstate) then
      s1 := yyldefault[yylstate]
    else
      s1 := yylnext[isc];
    {$else}
      s1 := yyldefault[yylstate]
    {$endif}
    if s1=-1 then
      begin
        yylterm := System.true;
        unput(c)
      end
    else
      begin
        yylterm := System.false;
        inc(yyleng); yytext[yyleng] := c;
        yylstate := s1
      end
  end(*yylterm*);
procedure yylback;
  var c : System.char;
  begin
    while yylpos>yylends[yylrule] do
      begin dec(yylpos); unput(yytext[yyleng]); dec(yyleng) end;
    if yylpos=1 then
      begin
        (* take default action *)
        yylpos0 := 0; yylrule0 := 0; c := input;
        if (c=#0) or (c=yylnl) then yylastate := 0 else yylastate := 1;
        if c<>#0 then output(c)
        else if yywrap then begin yylsstate := 0; return(0) end
      end
    else
      begin
        c := yytext[yyleng];
        yyleng0 := 0; yylpos0 := 0; yylrule0 := 0;
        yylaction(yylrule);
        if (c=#0) or (c=yylnl) then yylastate := 0 else yylastate := 1
      end
  end(*yylback*);
function yylex : System.integer;
  begin
    yylmatches[0] := 1; yylends[0] := 1;
    yylreturn := System.false;
    yyleng0 := 0; yylpos0 := 0; yylrule0 := 0;
    repeat
      yyleng := yyleng0; yylpos := yylpos0; yylrule := yylrule0;
      if yylpos=0 then
        begin
          (* initialize match table, end position table, and DFA state: *)
          fillChar(yylmatches[1],10,#0);
          fillChar(yylends[1],10,#0);
          yylstate := yylsstate+yylastate;
          while not yylterm do ;
        end;
      yylback;
    until yylreturn;
    yylex := yyltok
  end(*yylex*);



