
(* PL0.PAS: created 5-27-1992 at  2:13 pm
   by Yacc Version 2.0, Copyright (c) 1989 Albert Graef, all rights reserved *)


(*
 * File pl0.y
 *
 * PL0 grammar in Yacc format by H. Weber
 *
 * Extensions to PL/0:   else-part of if-statement
 *                       repeat-statement
 *                       read-statement
 *                       write-statement
 *)

USES
   PL0INIT, PL0CODE, PL0ERR, PL0SYMT,
   PL0LEX,  PL0STOP, LexLib, YaccLib;

VAR
   arrid : alfa;
   n, i, k: INTEGER;

 PROCEDURE yymsg(msg: string);
 BEGIN
   writeln(sourcefile, ':', line_no, ': ', msg, ' at or before `', act_token, '''.')
 END (*yymsg*);


var yychar : System.integer;
var yystack : array [1..yymaxdepth] of System.integer;
var yyvals : array [1..yymaxdepth] of yystype;
var yyval : yystype;
var yystackptr : System.integer;
var yyfail, yyacc, yyab : System.boolean;
var yynerrs, yyerr : System.integer;
procedure yyerror; begin yyfail := System.true end;
procedure yyerrok; begin yyerr := 0 end;
procedure yyaccept; begin yyacc := System.true end;
procedure yyabort; begin yyab := System.true end;
procedure yyclearin; begin yychar := -1 end;
procedure yyaction(yyrule : System.integer);
begin case yyrule of
1: ;
2: begin 
end(*2*);
3: begin  writeln(sourcefile, ':', line_no,
            ':Text follows logical end of program.'); 
end(*3*);
4: begin 
end(*4*);
5: begin  Error(9); 
end(*5*);
6: begin 
end(*6*);
7: begin 
end(*7*);
8: begin 
                        id:= yyvals[yystackptr-1+0].ident;
                        Enter(varobj, dindex[dindexptr], tx[txptr]);
                      
end(*8*);
9: begin 
                        id:= yyvals[yystackptr-2+0].ident;
                        arrid:= id;
                      
end(*9*);
10: begin 
                        id:= arrid;
                        Enter(arrobj, dindex[dindexptr], tx[txptr]);
                      
end(*10*);
11: begin  arrsize:= yyvals[yystackptr-1+0].number 
end(*11*);
12: begin 
                        id:= yyvals[yystackptr-1+0].ident;
                        i:= position(id, tx[txptr]);
                        IF i = 0 THEN
                           error(11)
                        ELSE WITH symtable[i] DO
                        CASE kind OF
                          constobj : arrsize:= Val;
                          varobj, procobj : error(46);
                        END;
                      
end(*12*);
13: begin 
                        txfirst:= tx[txptr]+1;
                        INC(pposptr);
                        IF pposptr>maxstack THEN Error(32);
                        ppos[pposptr]:= tx[txptr];
                        INC(dindexptr);
                        IF dindexptr>maxstack THEN Error(32);
                        dindex[dindexptr]:= 3;
                        symtable[tx[txptr]].addr:= codeindex;
                        Generate(jpu,0,0);
                        IF lev>nestmax THEN Error(32);
                      
end(*13*);
14: begin 
                        code[symtable[ppos[pposptr]].addr].a:= codeindex;
                        symtable[ppos[pposptr]].addr:= codeindex;
                        symtable[ppos[pposptr]].size:= dindex[dindexptr];
                        Generate(int,0,dindex[dindexptr]);
                        DEC(pposptr);
                        DEC(dindexptr);
                      
end(*14*);
15: begin 
                        Generate(ret,0,0);
                      
end(*15*);
16: begin 
end(*16*);
17: begin 
end(*17*);
18: begin  Error(5); 
end(*18*);
19: begin 
end(*19*);
20: begin  yyerrok; 
end(*20*);
21: begin 
end(*21*);
22: begin 
                        id:= yyvals[yystackptr-3+0].ident;
                        num:= yyvals[yystackptr-3+2].number;
                        Enter(constobj, dindex[dindexptr], tx[txptr]);
                      
end(*22*);
23: begin 
end(*23*);
24: begin 
end(*24*);
25: begin 
end(*25*);
26: begin 
end(*26*);
27: begin  yyerrok; 
end(*27*);
28: begin 
end(*28*);
29: begin 
                        DEC(txptr);
                        DEC(lev);
                      
end(*29*);
30: begin 
                        INC(txptr);
                        tx[txptr]:= tx[txptr-1];
                        INC(lev);
                      
end(*30*);
31: begin 
                        id:= yyvals[yystackptr-2+1].ident;
                        Enter(procobj, dindex[dindexptr], tx[txptr]);
                      
end(*31*);
32: begin 
end(*32*);
33: begin 
end(*33*);
34: begin 
end(*34*);
35: begin 
end(*35*);
36: begin 
end(*36*);
37: begin 
end(*37*);
38: begin 
end(*38*);
39: begin 
end(*39*);
40: begin 
end(*40*);
41: begin 
end(*41*);
42: begin 
end(*42*);
43: begin 
end(*43*);
44: begin 
                        id:= yyvals[yystackptr-3+0].ident;
                        i:= Position(id,tx[txptr]);
                        IF i=0 THEN
                          Error(11)
                        ELSE IF symtable[i].kind<>varobj THEN
                          Error(12);
                        WITH symtable[i]
                          DO Generate(sto,lev-level,addr);
                      
end(*44*);
45: begin 
                        id:= yyvals[yystackptr-2+0].ident;
                        i:= Position(id,tx[txptr]);
                        IF i=0 THEN
                          Error(11)
                        ELSE IF symtable[i].kind<>arrobj THEN
                          Error(49);
                        INC(arrptr);
                        IF arrptr>maxstack THEN Error(32);
                        arr[arrptr]:= i;
                      
end(*45*);
46: begin 
                        i:= arr[arrptr];
                        generate(lit,0,symtable[i].addr);
                        generate(add,0,0);
                      
end(*46*);
47: begin 
                        i:= arr[arrptr];
                        generate(sta,lev-symtable[i].level,0);
                        DEC(arrptr);
                      
end(*47*);
48: begin 
                        INC(caseptr);
                        caseinfo[caseptr].i:= 0;
                        caseinfo[caseptr].j:= 0;
                      
end(*48*);
49: begin 
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                        Generate(jpu,0,0);
                      
end(*49*);
50: begin 
                        code[fixup[fixupptr]].a:= codeindex;
                        FOR k:= 1 TO caseinfo[caseptr].i DO
                        BEGIN
                          Generate(lit,0,
                                   caseinfo[caseptr].casetab[k].value);
                          Generate(ldl,0,
                                   caseinfo[caseptr].casetab[k].cdindex);
                        END;
                        Generate(jpx,0,caseinfo[caseptr].i);
                        FOR k:= 1 TO caseinfo[caseptr].j DO
                          code[caseinfo[caseptr].exittab[k]].a:= codeindex;
                        DEC(fixupptr);
                        DEC(caseptr);
                      
end(*50*);
51: begin 
end(*51*);
52: begin 
end(*52*);
53: begin 
end(*53*);
54: begin 
end(*54*);
55: begin 
                        WITH caseinfo[caseptr] DO
                        BEGIN
                          IF i = casemax THEN
                            Error(37)
                          ELSE
                          BEGIN
                            INC(i);
                            num:= yyvals[yystackptr-1+0].number;
                            casetab[i].value:= num;
                            casetab[i].cdindex:= codeindex;
                            k:= 0;
                            REPEAT
                              INC(k)
                            UNTIL casetab[k].value = num;
                            IF k < i THEN
                              Error(40);
                          END;
                        END;
                      
end(*55*);
56: begin 
                        INC(caseinfo[caseptr].j);
                        caseinfo[caseptr].exittab[caseinfo[caseptr].j]
                          := codeindex;
                        Generate(jpu,0,0);
                      
end(*56*);
57: begin 
end(*57*);
58: begin 
end(*58*);
59: begin 
end(*59*);
60: begin 
                        writeln('statement ignored');
                        yyclearin
                      
end(*60*);
61: begin 
                        code[fixup[fixupptr]].a:= codeindex;
                        DEC(fixupptr);
                      
end(*61*);
62: begin 
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                        Generate(jpu,0,0);
                        code[fixup[fixupptr-1]].a:= codeindex;
                      
end(*62*);
63: begin 
                        code[fixup[fixupptr]].a:= codeindex;
                        DEC(fixupptr, 2);
                      
end(*63*);
64: begin 
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                        Generate(jpc,0,0);
                      
end(*64*);
65: begin 
end(*65*);
66: begin 
                        id:= yyvals[yystackptr-1+0].ident;
                        i:= Position(id,tx[txptr]);
                        IF i=0 THEN
                          Error(11)
                        ELSE IF symtable[i].kind <> varobj THEN
                          Error(12)
                        ELSE
                          WITH symtable[i] DO
                          BEGIN
                            Generate(lit,0,addr);
                            Generate(lda,lev-level,0)
                          END;
                      
end(*66*);
67: begin 
end(*67*);
68: begin 
                        id:= yyvals[yystackptr-2+0].ident;
                        i:= Position(id,tx[txptr]);
                        IF i=0 THEN
                          Error(11)
                        ELSE IF symtable[i].kind <> arrobj THEN
                          Error(49);
                        INC(arrptr);
                        IF arrptr>maxstack THEN Error(32);
                        arr[arrptr]:= i;
                        generate(lit,0,symtable[i].addr);
                      
end(*68*);
69: begin 
                        i:= arr[arrptr];
                        generate(add,0,0);
                        generate(lda,lev-symtable[i].level, 0);
                        DEC(arrptr);
                      
end(*69*);
70: begin 
end(*70*);
71: begin 
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                        Generate(feu,0,0);
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                      
end(*71*);
72: begin 
                        Generate(fru,0,fixup[fixupptr]);
                        DEC(fixupptr);
                        code[fixup[fixupptr]].a:= codeindex;
                        DEC(fixupptr);
                      
end(*72*);
73: begin 
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                        Generate(fed,0,0);
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                      
end(*73*);
74: begin 
                        Generate(frd,0,fixup[fixupptr]);
                        DEC(fixupptr);
                        code[fixup[fixupptr]].a:= codeindex;
                        DEC(fixupptr);
                      
end(*74*);
75: begin 
                        id:= yyvals[yystackptr-2+1].ident;
                        i:= Position(id,tx[txptr]);
                        IF i=0 THEN
                          Error(11)
                        ELSE
                          WITH symtable[i] DO
                          IF kind=procobj THEN
                            Generate(cal,lev-level,addr)
                          ELSE
                            Error(15);
                      
end(*75*);
76: begin 
                        id:= yyvals[yystackptr-4+2].ident;
                        i:= Position(id,tx[txptr]);
                        IF i=0 THEN
                          Error(11)
                        ELSE IF symtable[i].kind<>varobj THEN
                          Error(12);
                        Generate(inp,0,0);
                        WITH symtable[i] DO
                          Generate(sto,lev-level,addr);
                      
end(*76*);
77: begin 
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                      
end(*77*);
78: begin 
                        Generate(jpc,0,fixup[fixupptr]);
                        DEC(fixupptr);
                      
end(*78*);
79: begin 
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                      
end(*79*);
80: begin 
                        INC(fixupptr);
                        IF fixupptr>maxstack THEN Error(32);
                        fixup[fixupptr]:= codeindex;
                        Generate(jpc,0,0);
                      
end(*80*);
81: begin 
                        Generate(jpu,0,fixup[fixupptr-1]);
                        code[fixup[fixupptr]].a:= codeindex;
                        DEC(fixupptr, 2);
                      
end(*81*);
82: begin 
end(*82*);
83: begin 
end(*83*);
84: begin 
end(*84*);
85: begin  Generate(prn,0,0); 
end(*85*);
86: begin 
                        str:= yyvals[yystackptr-1+0].ident;
                        n:= length(str);
                        Generate(prs,0,n);
                        for i:= 1 to n do
                           Generate(asc,0,ord(str[i]));
                      
end(*86*);
87: begin  Generate(prl,0,0); 
end(*87*);
88: begin  Generate(od ,0,0); 
end(*88*);
89: begin  Generate(eq ,0,0); 
end(*89*);
90: begin  Generate(ne ,0,0); 
end(*90*);
91: begin  Generate(ls ,0,0); 
end(*91*);
92: begin  Generate(gt ,0,0); 
end(*92*);
93: begin  Generate(le ,0,0); 
end(*93*);
94: begin  Generate(ge ,0,0); 
end(*94*);
95: begin 
end(*95*);
96: begin  Generate(neg,0,0); 
end(*96*);
97: begin  Generate(add,0,0); 
end(*97*);
98: begin  Generate(sub,0,0); 
end(*98*);
99: begin  Generate(mpy,0,0); 
end(*99*);
100: begin  Generate(dvd,0,0); 
end(*100*);
101: begin 
                        id:= yyvals[yystackptr-1+0].ident;
                        i:= Position(id,tx[txptr]);
                        IF i=0 THEN
                          Error(11)
                        ELSE
                          WITH symtable[i] DO
                          CASE kind OF
                            constobj: Generate(lit,0,val);
                            varobj  : Generate(lod,lev-level,addr);
                            arrobj  : Error(50);
                            procobj : Error(21);
                          END;
                      
end(*101*);
102: begin 
                        id:= yyvals[yystackptr-2+0].ident;
                        i:= Position(id,tx[txptr]);
                        INC(arrptr);
                        IF arrptr>maxstack THEN Error(32);
                        arr[arrptr]:= i;
                        IF i=0 THEN
                          Error(11)
                        ELSE IF symtable[i].kind <> arrobj THEN
                          Error(49);
                      
end(*102*);
103: begin 
                        i:= arr[arrptr];
                        DEC(arrptr);
                        generate(lit,0,symtable[i].addr);
                        generate(add,0,0);
                        generate(drf,lev-symtable[i].level,0);
                      
end(*103*);
104: begin 
                        num:= yyvals[yystackptr-1+0].number;
                        Generate(lit,0,num);
                      
end(*104*);
105: begin 
end(*105*);
end(*case*);
end(*yyaction*);

const _ = -11111;
const yyerrortok = -256;
const yyrules = 105;
const yystates = 183;
const yyentries = 1453;
const yyrulesize : array [1..yyrules] of System.integer = (
  2,
  1,
  2,
  2,
  2,
  3,
  1,
  1,
  0,
  5,
  1,
  1,
  0,
  0,
  7,
  0,
  3,
  3,
  0,
  3,
  1,
  3,
  3,
  0,
  2,
  0,
  3,
  1,
  2,
  2,
  2,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  0,
  3,
  0,
  0,
  8,
  0,
  0,
  7,
  1,
  2,
  3,
  1,
  0,
  4,
  3,
  3,
  1,
  1,
  2,
  0,
  5,
  3,
  3,
  0,
  4,
  0,
  0,
  8,
  0,
  5,
  0,
  5,
  2,
  4,
  0,
  5,
  0,
  0,
  6,
  4,
  3,
  1,
  1,
  1,
  1,
  2,
  3,
  3,
  3,
  3,
  3,
  3,
  1,
  2,
  3,
  3,
  3,
  3,
  1,
  0,
  5,
  1,
  3);
const yylsym : array [1..yyrules] of System.integer = (
  1,
  2,
  2,
  3,
  3,
  5,
  5,
  6,
  7,
  6,
  8,
  8,
  10,
  14,
  4,
  9,
  11,
  11,
  11,
  16,
  16,
  17,
  12,
  12,
  13,
  13,
  18,
  18,
  19,
  20,
  21,
  15,
  15,
  15,
  15,
  15,
  15,
  15,
  15,
  15,
  15,
  15,
  15,
  22,
  34,
  35,
  22,
  36,
  37,
  23,
  38,
  38,
  39,
  39,
  41,
  40,
  24,
  42,
  42,
  42,
  25,
  44,
  25,
  43,
  26,
  48,
  46,
  49,
  50,
  46,
  51,
  47,
  52,
  47,
  27,
  28,
  53,
  29,
  54,
  55,
  30,
  31,
  56,
  56,
  57,
  57,
  32,
  45,
  45,
  45,
  45,
  45,
  45,
  45,
  33,
  33,
  33,
  33,
  33,
  33,
  58,
  59,
  58,
  58,
  58);
const yydefault : array [0..yystates] of System.integer = (
  -16,
  _,
  _,
  _,
  -13,
  -3,
  -5,
  -4,
  _,
  _,
  _,
  _,
  _,
  _,
  -21,
  _,
  -14,
  _,
  -28,
  -16,
  _,
  _,
  _,
  -7,
  _,
  -18,
  _,
  -17,
  _,
  _,
  _,
  -29,
  -30,
  -31,
  _,
  -23,
  -9,
  -20,
  -22,
  -15,
  -32,
  -33,
  -34,
  -35,
  -36,
  -37,
  -38,
  -39,
  -40,
  -41,
  -42,
  _,
  _,
  _,
  _,
  -48,
  _,
  _,
  _,
  -77,
  -79,
  _,
  -87,
  -27,
  -6,
  _,
  _,
  _,
  -45,
  -59,
  _,
  -60,
  -75,
  _,
  _,
  _,
  _,
  _,
  -95,
  _,
  _,
  -104,
  _,
  _,
  _,
  _,
  _,
  _,
  _,
  -11,
  -12,
  -62,
  _,
  _,
  -57,
  _,
  _,
  -65,
  _,
  _,
  _,
  -68,
  _,
  _,
  _,
  _,
  _,
  _,
  _,
  _,
  _,
  _,
  -64,
  -96,
  _,
  -102,
  _,
  _,
  _,
  -80,
  _,
  _,
  -84,
  -86,
  -10,
  _,
  _,
  -58,
  -49,
  _,
  _,
  _,
  _,
  _,
  _,
  -99,
  -100,
  _,
  _,
  _,
  _,
  _,
  _,
  -105,
  _,
  -76,
  _,
  _,
  -82,
  _,
  -63,
  -46,
  _,
  -73,
  -71,
  _,
  _,
  _,
  -78,
  _,
  -83,
  _,
  _,
  _,
  -54,
  -55,
  _,
  _,
  -69,
  -103,
  -81,
  _,
  -50,
  _,
  _,
  -74,
  -72,
  _,
  _,
  -53,
  _,
  _,
  -56,
  _);
const yybase : array [0..yystates] of System.integer = (
  1,
  1,
  258,
  281,
  1,
  1,
  1,
  1,
  313,
  352,
  272,
  391,
  273,
  303,
  1,
  295,
  3,
  312,
  1,
  18,
  318,
  291,
  322,
  1,
  333,
  1,
  294,
  1,
  296,
  430,
  469,
  1,
  1,
  1,
  299,
  1,
  28,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  508,
  330,
  555,
  301,
  1,
  306,
  368,
  303,
  2,
  2,
  325,
  1,
  1,
  1,
  330,
  523,
  332,
  36,
  1,
  367,
  1,
  1,
  370,
  371,
  360,
  477,
  373,
  1,
  378,
  406,
  1,
  604,
  417,
  344,
  650,
  446,
  534,
  372,
  1,
  1,
  41,
  726,
  556,
  1,
  777,
  494,
  1,
  561,
  598,
  353,
  39,
  627,
  636,
  653,
  663,
  680,
  685,
  695,
  778,
  780,
  806,
  1,
  1,
  700,
  35,
  821,
  362,
  412,
  47,
  831,
  396,
  1,
  1,
  1,
  903,
  540,
  1,
  82,
  760,
  875,
  814,
  904,
  1026,
  1137,
  1,
  1,
  965,
  1053,
  1163,
  1168,
  1216,
  1242,
  1,
  916,
  1,
  1045,
  394,
  1,
  980,
  1,
  90,
  623,
  75,
  77,
  960,
  1074,
  1081,
  1,
  1270,
  1,
  399,
  411,
  445,
  1,
  98,
  1309,
  1349,
  90,
  1,
  1,
  1090,
  1,
  442,
  414,
  1,
  1,
  411,
  1364,
  1,
  1410,
  1092,
  1,
  1212);
{$define yytable}
const yynext : array [1..yyentries] of System.integer = (
  0, 5, 1, 2, 3,
  7, 15, 24, 27, 4,
  8, -19, -19, -19, -19,
  28, 29, 30, -19, -19,
  -19, 31, -19, 32, 6,
  33, 4, 35, 15, -19,
  26, 38, -19, 24, 65,
  72, 73, -19, -8, 10,
  75, 84, -19, -19, -19,
  68, 25, -19, 36, 34,
  -24, -24, -24, 12, 85,
  86, -19, -24, -24, -24,
  -8, -24, 67, 87, 90,
  89, 82, 81, -24, 93,
  80, -24, 95, 79, 99,
  101, -24, 112, 117, 83,
  124, -24, -24, -24, 125,
  131, -24, 132, 94, -26,
  -26, -26, -66, 144, 98,
  -24, -26, -26, -26, 145,
  21, 147, 82, 81, 82,
  81, 80, -26, 80, 79,
  -26, 79, 82, 81, 146,
  -26, 80, 95, 152, 159,
  -26, -26, -26, 149, 161,
  -26, 166, 167, 62, 61,
  60, 171, 172, 148, -26,
  -43, 59, 58, 174, 177,
  82, 81, 180, 181, 80,
  _, 57, 79, _, 56,
  173, 82, 81, _, -43,
  80, _, 83, 79, 55,
  54, 53, _, -52, 52,
  _, -51, -25, -25, -25,
  _, _, _, -43, -25,
  -25, -25, 165, 21, _,
  82, 81, _, _, 80,
  -25, _, 79, -25, 111,
  110, 109, _, -25, 108,
  107, _, 106, -25, -25,
  -25, _, _, -25, 128,
  _, 62, 61, 60, _,
  -43, _, -25, -43, 59,
  58, 105, 104, 103, 102,
  _, _, _, _, 57,
  -61, _, 56, -61, -43,
  -43, _, -43, 105, 104,
  103, 102, 55, 54, 53,
  _, _, 52, _, -61,
  91, _, -61, 151, _,
  _, -43, _, 62, 61,
  60, _, -2, _, _,
  -43, 59, 58, _, _,
  _, -61, 123, 82, 81,
  _, 57, 80, _, 56,
  79, -43, 22, 23, 105,
  104, 103, 102, _, 55,
  54, 53, 13, 14, 52,
  82, 81, _, _, 80,
  82, 81, 79, 71, 80,
  _, _, 79, _, 64,
  _, -101, -101, -101, -101,
  37, _, -101, _, -101,
  _, -101, -101, -101, 115,
  _, -101, -101, 9, -101,
  -101, -101, -101, -101, -101,
  _, -101, 82, 81, _,
  _, 80, 88, _, 79,
  _, -101, _, -101, -101,
  -101, -101, -101, 62, 61,
  60, 74, -43, _, _,
  -43, 59, 58, 165, _,
  _, 82, 81, 11, 92,
  80, 57, _, 79, 56,
  82, 81, _, _, 80,
  _, _, 79, _, 55,
  54, 53, _, _, 52,
  _, _, 82, 81, 78,
  _, 80, _, 71, 79,
  _, _, 82, 81, _,
  76, 80, 96, 16, 79,
  _, _, 100, 17, 18,
  19, 20, 77, _, 82,
  81, _, 97, 80, 82,
  81, 79, _, 80, _,
  78, 79, 78, -44, 82,
  81, -44, _, 80, _,
  113, 79, 143, 114, 105,
  104, 103, 102, _, 39,
  _, _, -44, -44, 116,
  -44, 40, 41, 42, 43,
  44, 45, 46, 47, 48,
  49, 50, _, 78, _,
  105, 104, 103, 102, -44,
  _, _, 51, _, 78,
  62, 61, 60, 76, -43,
  _, 179, -43, 59, 58,
  153, _, 63, 19, 20,
  119, _, _, 57, _,
  _, 56, _, -43, 105,
  104, 103, 102, 78, _,
  _, 55, 54, 53, _,
  _, 52, 82, 81, 82,
  81, 80, _, 80, 79,
  _, 79, 66, -88, _,
  -88, -88, _, _, 40,
  41, 42, 43, 44, 45,
  46, 47, 48, 49, 50,
  82, 81, -88, -88, 80,
  -88, -88, 79, 82, 81,
  51, _, 80, _, _,
  79, _, _, -85, _,
  105, 104, 103, 102, -88,
  _, 120, _, -85, 69,
  105, 104, 103, 102, _,
  _, 40, 41, 42, 43,
  44, 45, 46, 47, 48,
  49, 50, _, 126, 121,
  122, 78, _, 129, _,
  _, 70, 51, _, _,
  154, 62, 61, 60, _,
  -43, _, _, -43, 59,
  58, _, _, 78, 105,
  104, 103, 102, 78, 57,
  _, _, 56, _, -43,
  -43, _, -43, _, _,
  130, _, 55, 54, 53,
  _, _, 52, 82, 81,
  _, _, 80, _, _,
  79, -43, _, _, _,
  82, 81, _, _, 80,
  78, _, 79, _, 133,
  162, 163, 164, -67, 69,
  _, _, -89, 134, -89,
  -89, 40, 41, 42, 43,
  44, 45, 46, 47, 48,
  49, 50, _, -67, 78,
  135, -89, -89, _, -89,
  -89, 118, 51, 78, _,
  136, _, _, _, 105,
  104, 103, 102, _, 105,
  104, 103, 102, -89, _,
  78, _, 137, 123, 82,
  81, _, 138, 80, _,
  78, 79, _, _, _,
  _, _, 139, -97, -97,
  -97, -97, _, _, -97,
  _, -97, 78, -97, -97,
  -97, _, 78, -97, -97,
  _, -97, -97, -97, -97,
  -97, -97, 78, -97, _,
  -94, 83, -94, -94, _,
  _, _, _, -97, _,
  105, 104, -97, -97, -97,
  _, _, _, _, -94,
  -94, _, -94, -94, 82,
  81, _, 168, 80, _,
  _, 79, _, _, 169,
  _, 127, 105, 104, 103,
  102, -94, _, 40, 41,
  42, 43, 44, 45, 46,
  47, 48, 49, 50, _,
  140, _, 141, 105, 104,
  103, 102, _, _, 51,
  105, 104, 103, 102, 82,
  81, 82, 81, 80, _,
  80, 79, _, 79, _,
  78, _, 78, 142, -98,
  -98, -98, -98, _, _,
  -98, 155, -98, _, -98,
  -98, -98, _, _, -98,
  -98, _, -98, -98, -98,
  -98, -98, -98, 78, -98,
  -92, _, -92, -92, _,
  -93, 78, -93, -93, -98,
  _, 105, 104, -98, -98,
  -98, _, _, _, -92,
  -92, _, -92, -92, -93,
  -93, _, -93, -93, _,
  _, _, _, _, _,
  _, _, 105, 104, 103,
  102, -92, 105, 104, 103,
  102, -93, _, _, _,
  -70, _, 150, -91, _,
  -91, -91, _, _, 40,
  41, 42, 43, 44, 45,
  46, 47, 48, 49, 50,
  -70, 156, -91, -91, _,
  -91, -91, _, _, -90,
  51, -90, -90, 157, _,
  _, 105, 104, 103, 102,
  105, 104, 103, 102, -91,
  _, 78, _, -90, -90,
  _, -90, -90, 62, 61,
  60, _, -43, 78, _,
  -43, 59, 58, _, _,
  _, 105, 104, 103, 102,
  -90, 57, _, _, 56,
  _, -43, -43, _, -43,
  _, _, _, _, 55,
  54, 53, _, _, 52,
  _, _, 62, 61, 60,
  _, -43, 120, -43, -43,
  59, 58, _, _, _,
  _, _, _, _, _,
  57, _, _, 56, _,
  -43, -43, _, -43, _,
  _, 160, 78, 55, 54,
  53, _, _, 52, _,
  _, _, 62, 61, 60,
  _, -43, -43, _, -43,
  59, 58, _, _, _,
  _, _, _, _, _,
  57, -47, _, 56, -47,
  -43, -43, _, -43, _,
  _, _, 76, 55, 54,
  53, _, _, 52, _,
  -47, -47, _, -47, 158,
  _, _, -43, _, _,
  _, _, _, _, _,
  _, _, 78, 105, 104,
  103, 102, -47, 62, 61,
  60, _, _, _, _,
  -43, 59, 58, _, _,
  _, _, 178, _, 183,
  _, 57, _, _, 56,
  _, -43, _, _, _,
  _, _, _, _, 55,
  54, 53, _, _, 52,
  _, _, 78, _, 78,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, 170,
  _, _, _, _, _,
  _, 40, 41, 42, 43,
  44, 45, 46, 47, 48,
  49, 50, _, _, _,
  _, _, _, _, _,
  _, _, 51, _, _,
  _, _, _, _, _,
  _, _, _, 175, _,
  _, _, _, _, _,
  40, 41, 42, 43, 44,
  45, 46, 47, 48, 49,
  50, _, _, _, _,
  _, _, _, _, _,
  _, 51, _, _, _,
  _, _, _, _, _,
  _, _, _, 176, _,
  _, _, _, _, _,
  40, 41, 42, 43, 44,
  45, 46, 47, 48, 49,
  50, _, _, _, _,
  _, _, _, _, _,
  _, 51, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, 182,
  _, _, _, _, _,
  _, 40, 41, 42, 43,
  44, 45, 46, 47, 48,
  49, 50, _, _, _,
  _, _, _, _, _,
  _, _, 51);
const yycheck : array [1..yyentries] of System.integer = (
  1, 2, 0, 0, 0,
  3, 10, 12, 13, 0,
  4, 8, 8, 8, 8,
  15, 16, 17, 8, 8,
  8, 19, 8, 20, 3,
  21, 19, 22, 26, 8,
  13, 28, 8, 34, 36,
  54, 55, 8, 24, 8,
  56, 58, 8, 8, 8,
  52, 13, 8, 24, 22,
  9, 9, 9, 9, 59,
  60, 8, 9, 9, 9,
  24, 9, 52, 61, 65,
  65, 67, 67, 9, 68,
  67, 9, 70, 67, 74,
  75, 9, 77, 84, 57,
  88, 9, 9, 9, 91,
  100, 9, 101, 70, 11,
  11, 11, 75, 115, 74,
  9, 11, 11, 11, 117,
  11, 119, 57, 57, 73,
  73, 57, 11, 73, 57,
  11, 73, 79, 79, 118,
  11, 79, 118, 128, 147,
  11, 11, 11, 121, 151,
  11, 153, 154, 29, 29,
  29, 161, 162, 121, 11,
  29, 29, 29, 165, 168,
  80, 80, 174, 177, 80,
  _, 29, 80, _, 29,
  163, 83, 83, _, 29,
  83, _, 86, 83, 29,
  29, 29, _, 173, 29,
  _, 163, 30, 30, 30,
  _, _, _, 29, 30,
  30, 30, 173, 30, _,
  86, 86, _, _, 86,
  30, _, 86, 30, 76,
  76, 76, _, 30, 76,
  76, _, 76, 30, 30,
  30, _, _, 30, 96,
  _, 51, 51, 51, _,
  51, _, 30, 51, 51,
  51, 76, 76, 76, 76,
  _, _, _, _, 51,
  66, _, 51, 66, 51,
  51, _, 51, 96, 96,
  96, 96, 51, 51, 51,
  _, _, 51, _, 66,
  66, _, 66, 126, _,
  _, 51, _, 53, 53,
  53, _, 2, _, _,
  53, 53, 53, _, _,
  _, 66, 87, 87, 87,
  _, 53, 87, _, 53,
  87, 53, 12, 12, 126,
  126, 126, 126, _, 53,
  53, 53, 10, 10, 53,
  93, 93, _, _, 93,
  98, 98, 93, 53, 98,
  _, _, 98, _, 34,
  _, 82, 82, 82, 82,
  26, _, 82, _, 82,
  _, 82, 82, 82, 82,
  _, 82, 82, 8, 82,
  82, 82, 82, 82, 82,
  _, 82, 99, 99, _,
  _, 99, 65, _, 99,
  _, 82, _, 82, 82,
  82, 82, 82, 85, 85,
  85, 56, 85, _, _,
  85, 85, 85, 152, _,
  _, 102, 102, 9, 67,
  102, 85, _, 102, 85,
  103, 103, _, _, 103,
  _, _, 103, _, 85,
  85, 85, _, _, 85,
  _, _, 104, 104, 67,
  _, 104, _, 85, 104,
  _, _, 105, 105, _,
  57, 105, 73, 11, 105,
  _, _, 75, 11, 11,
  11, 11, 57, _, 106,
  106, _, 74, 106, 107,
  107, 106, _, 107, _,
  57, 107, 73, 92, 108,
  108, 92, _, 108, _,
  79, 108, 114, 80, 114,
  114, 114, 114, _, 29,
  _, _, 92, 92, 83,
  92, 29, 29, 29, 29,
  29, 29, 29, 29, 29,
  29, 29, _, 80, _,
  92, 92, 92, 92, 92,
  _, _, 29, _, 83,
  95, 95, 95, 86, 95,
  _, 173, 95, 95, 95,
  129, _, 30, 30, 30,
  86, _, _, 95, _,
  _, 95, _, 95, 129,
  129, 129, 129, 86, _,
  _, 95, 95, 95, _,
  _, 95, 109, 109, 110,
  110, 109, _, 110, 109,
  _, 110, 51, 116, _,
  116, 116, _, _, 51,
  51, 51, 51, 51, 51,
  51, 51, 51, 51, 51,
  111, 111, 116, 116, 111,
  116, 116, 111, 131, 131,
  51, _, 131, _, _,
  131, _, _, 120, _,
  116, 116, 116, 116, 116,
  _, 87, _, 120, 53,
  120, 120, 120, 120, _,
  _, 53, 53, 53, 53,
  53, 53, 53, 53, 53,
  53, 53, _, 93, 87,
  87, 87, _, 98, _,
  _, 53, 53, _, _,
  130, 125, 125, 125, _,
  125, _, _, 125, 125,
  125, _, _, 93, 130,
  130, 130, 130, 98, 125,
  _, _, 125, _, 125,
  125, _, 125, _, _,
  99, _, 125, 125, 125,
  _, _, 125, 132, 132,
  _, _, 132, _, _,
  132, 125, _, _, _,
  144, 144, _, _, 144,
  99, _, 144, _, 102,
  152, 152, 152, 155, 85,
  _, _, 137, 103, 137,
  137, 85, 85, 85, 85,
  85, 85, 85, 85, 85,
  85, 85, _, 155, 102,
  104, 137, 137, _, 137,
  137, 85, 85, 103, _,
  105, _, _, _, 155,
  155, 155, 155, _, 137,
  137, 137, 137, 137, _,
  104, _, 106, 149, 149,
  149, _, 107, 149, _,
  105, 149, _, _, _,
  _, _, 108, 133, 133,
  133, 133, _, _, 133,
  _, 133, 106, 133, 133,
  133, _, 107, 133, 133,
  _, 133, 133, 133, 133,
  133, 133, 108, 133, _,
  138, 146, 138, 138, _,
  _, _, _, 133, _,
  133, 133, 133, 133, 133,
  _, _, _, _, 138,
  138, _, 138, 138, 146,
  146, _, 156, 146, _,
  _, 146, _, _, 157,
  _, 95, 138, 138, 138,
  138, 138, _, 95, 95,
  95, 95, 95, 95, 95,
  95, 95, 95, 95, _,
  109, _, 110, 156, 156,
  156, 156, _, _, 95,
  157, 157, 157, 157, 171,
  171, 181, 181, 171, _,
  181, 171, _, 181, _,
  109, _, 110, 111, 134,
  134, 134, 134, _, _,
  134, 131, 134, _, 134,
  134, 134, _, _, 134,
  134, _, 134, 134, 134,
  134, 134, 134, 111, 134,
  139, _, 139, 139, _,
  140, 131, 140, 140, 134,
  _, 134, 134, 134, 134,
  134, _, _, _, 139,
  139, _, 139, 139, 140,
  140, _, 140, 140, _,
  _, _, _, _, _,
  _, _, 139, 139, 139,
  139, 139, 140, 140, 140,
  140, 140, _, _, _,
  183, _, 125, 141, _,
  141, 141, _, _, 125,
  125, 125, 125, 125, 125,
  125, 125, 125, 125, 125,
  183, 132, 141, 141, _,
  141, 141, _, _, 142,
  125, 142, 142, 144, _,
  _, 183, 183, 183, 183,
  141, 141, 141, 141, 141,
  _, 132, _, 142, 142,
  _, 142, 142, 159, 159,
  159, _, 159, 144, _,
  159, 159, 159, _, _,
  _, 142, 142, 142, 142,
  142, 159, _, _, 159,
  _, 159, 159, _, 159,
  _, _, _, _, 159,
  159, 159, _, _, 159,
  _, _, 166, 166, 166,
  _, 166, 149, 159, 166,
  166, 166, _, _, _,
  _, _, _, _, _,
  166, _, _, 166, _,
  166, 166, _, 166, _,
  _, 149, 149, 166, 166,
  166, _, _, 166, _,
  _, _, 167, 167, 167,
  _, 167, 166, _, 167,
  167, 167, _, _, _,
  _, _, _, _, _,
  167, 178, _, 167, 178,
  167, 167, _, 167, _,
  _, _, 146, 167, 167,
  167, _, _, 167, _,
  178, 178, _, 178, 146,
  _, _, 167, _, _,
  _, _, _, _, _,
  _, _, 146, 178, 178,
  178, 178, 178, 180, 180,
  180, _, _, _, _,
  180, 180, 180, _, _,
  _, _, 171, _, 181,
  _, 180, _, _, 180,
  _, 180, _, _, _,
  _, _, _, _, 180,
  180, 180, _, _, 180,
  _, _, 171, _, 181,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, 159,
  _, _, _, _, _,
  _, 159, 159, 159, 159,
  159, 159, 159, 159, 159,
  159, 159, _, _, _,
  _, _, _, _, _,
  _, _, 159, _, _,
  _, _, _, _, _,
  _, _, _, 166, _,
  _, _, _, _, _,
  166, 166, 166, 166, 166,
  166, 166, 166, 166, 166,
  166, _, _, _, _,
  _, _, _, _, _,
  _, 166, _, _, _,
  _, _, _, _, _,
  _, _, _, 167, _,
  _, _, _, _, _,
  167, 167, 167, 167, 167,
  167, 167, 167, 167, 167,
  167, _, _, _, _,
  _, _, _, _, _,
  _, 167, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, _,
  _, _, _, _, 180,
  _, _, _, _, _,
  _, 180, 180, 180, 180,
  180, 180, 180, 180, 180,
  180, 180, _, _, _,
  _, _, _, _, _,
  _, _, 180);
function yyparse : System.integer;
  var s : System.integer;
  function next(s, sym : System.integer) : System.integer;
    var i : System.integer;
    begin
      {$ifdef yytable}
      i := yybase[s]+sym;
      if (1<=i) and (i<=yyentries) and (yycheck[i]=s) then
        next := yynext[i]
      else
        next := yydefault[s]
      {$else}
        next := yydefault[s]
      {$endif}
    end(*next*);
  procedure shift(s1 : System.integer);
    begin
      {$ifdef yydebug}
      yydebugmsg(s, 'shift', s1);
      {$endif}
      if yystackptr>yymaxdepth then begin yymsg('yyparse: stack overflow'); yyabort; exit end;
      s := s1;
      yystack[yystackptr] := s;
      yyvals[yystackptr] := yylval;
      inc(yystackptr);
      if yyerr>0 then dec(yyerr)
    end(*shift*);
  procedure error;
    procedure recover;
      begin
        {$ifdef yydebug}
        yydebugmsg(s, '** error **', -1);
        {$endif}
        while (yystackptr>2) and (next(s, yyerrortok)<0) do
          begin
            {$ifdef yydebug}
            yydebugmsg(s, 'recovery pops stack', -1);
            {$endif}
            dec(yystackptr);
            s := yystack[System.pred(yystackptr)]
          end;
        yyerr := 4;
        if next(s, yyerrortok)>=0 then
          shift(next(s, yyerrortok))
        else
          yyabort;
      end(*recover*);
    begin
      case yyerr of
        0: begin yymsg('syntax error'); inc(yynerrs); recover end;
        1,2: recover;
        3: if yychar=0 then
             yyabort
           else
             begin
               {$ifdef yydebug}
               yydebugmsg(s, 'recovery discards', yychar);
               {$endif}
               yychar := -1;
             end;
      end;
    end(*error*);
  procedure reduce(p : System.integer);
    begin
      {$ifdef yydebug}
      yydebugmsg(s, 'reduce by rule', System.pred(p));
      {$endif}
      yyaction(p);
      dec(yystackptr, yyrulesize[p]);
      s := yystack[System.pred(yystackptr)];
      if yystackptr>yymaxdepth then begin yymsg('yyparse: stack overflow'); yyabort; exit end;
      {$ifdef yydebug}
      yydebugmsg(s, 'goto', next(s, yylsym[p]));
      {$endif}
      s := next(s, yylsym[p]);
      yystack[yystackptr] := s;
      yyvals[yystackptr] := yyval;
      inc(yystackptr)
    end(*reduce*);
  begin
    yyacc := System.false; yyab := System.false;
    yyerr := 0; yynerrs := 0;
    yyfail := System.false;
    s := 0;
    yystack[1] := s;
    yystackptr := 2;
    yychar := -1;
    repeat
      if yydefault[s]<>_ then
        reduce(-yydefault[s])
      else
        begin
          if yychar=-1 then
            begin
              yychar := yylex; if yychar<0 then yychar := 0;
              {$ifdef yydebug}
              yydebugmsg(s, 'reading', yychar);
              {$endif}
            end;
          if yyfail or (next(s, -yychar)=_) then
            error
          else if next(s, -yychar)<0 then
            reduce(-next(s, -yychar))
          else if yychar=0 then
            yyaccept
          else
            begin
              shift(next(s, -yychar));
              yychar := -1
            end
        end
    until yyacc or yyab;
    {$ifdef yydebug}
    if yyacc then
      yydebugmsg(s, 'accept', -1)
    else
      yydebugmsg(s, 'abort', -1);
    {$endif}
    if yyacc then
      yyparse := 0
    else
      yyparse := 1
  end(*yyparse*);


begin
   fixupptr := 0;
   pposptr  := 0;
   dindexptr:= 0;
   caseptr  := 0;
   txptr    := 1;
   arrptr   := 0;
   tx[1]    := 0;
   lev      := 0;

   if (yyparse=0) and (errorsw=no) then
      Writeln('Compilation successfull.')
   else
   begin
      errorsw:= yes;
      WriteLn('Compilation not successfull.');
   end;
   stop;
end.